mod codegen;
mod flags;
mod fuzz_tests;
mod utils;
mod dist;

use anyhow::Result;
use xshell::{cmd, pushd};

fn main() -> Result<()> {
    use flags::{Xtask, XtaskCmd::*};

    let _d = pushd(utils::project_root())?;

    let flags = Xtask::from_env()?;

    match flags.subcommand {
        Help(_) => println!("{}", Xtask::HELP),
        Codegen(cmd) => cmd.run()?,
        FuzzTests(cmd) => cmd.run()?,
        _ => (),
    };

    Ok(())
}
